#!/bin/sh

# reinhard@finalmedia.de
# Do 6. Apr 10:44:30 CEST 2023

# you need to install imagemagick, xxd, fold and gawk (gnu awk)
# in order to use this script!

# reads all type of images, supported by imagemagick
# converts them to rgb values, parses lines and writes
# fbdraw commands on stdout.

# CAVEAT: You need to know the WIDTH in pixels of input data!
# first parameter of this script is width in pixels.

# Example to covert JPG image data, 640 x 200 to fbdraw commands (plaintext)
# and compress the output on the fly, write to file.

# Example Usage: ./img2txt.sh 640 < input.jpg | gzip -9 > output.txt.gz

# Hint: Just use grep to omit unwanted color values. if you need to remove
# a black background, you would use
# ./img2txt.sh 256 < image.png | grep -v ".* 0 0 0$" | gzip -9 > image.txt.gz


test $# -lt 1 && echo "Usage: $0 width < input.jpg > output.txt" && exit 1

w=$(echo "$1" | tr -dc "0-9")

convert - rgb:- | \
xxd -ps | tr -dc "0-9a-f" | \
fold -w 6 | cat -n | \
head -n -1 | \
awk "{print \"p \" \
int(\$1%$w) \" \" \
int(\$1/$w) \" \" \
strtonum(\"0x\"substr(\$2,1,2)) \" \" \
strtonum(\"0x\"substr(\$2,3,2)) \" \" \
strtonum(\"0x\"substr(\$2,5,2)) }"
